﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.IO;
using System.Net;

namespace OMS
{
    public partial class SendSMS1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
        }

        public Boolean SendSMSMessage(string strUsername, string strPassword, string strSender, string strMSISDN, string strMsg, string strMsgType)
        {
            Boolean blRet = false;
            const int bufSizeMax = 65536; // max read buffer size conserves memory
            const int bufSizeMin = 8192;  // min size prevents numerous small reads
            StringBuilder sb;
            Stream requestStream = null;
            Stream responseStream = null;
            try
            {
                string strEnc = "";
                if (strMsgType.EndsWith("T"))
                {
                    strEnc = "UTF-8";                   
                }
                else
                    strEnc = "us-ascii";
                string strUrl = "http://tunnel.911itwist.com:8080/servlet/sendSMS.do";
                string strXml = "<?xml version=\"1.0\" encoding=\"" + strEnc + "\"?><transaction><id>" + DateTime.Now.ToString("yyMMddHHmmssms") + "</id><msisdn>" + strMSISDN + "</msisdn><msgtype>" + strMsgType + "</msgtype><msdata>" + strMsg + "</msdata><sender>" + strSender + "</sender></transaction>";
                byte[] bytes = Encoding.UTF8.GetBytes(strXml);

                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(strUrl);
                request.Credentials = CredentialCache.DefaultCredentials;
                request.Method = WebRequestMethods.Http.Post;
                request.ProtocolVersion = HttpVersion.Version11;
                request.ContentType = "text/xml; charset=UTF-8";
                request.ContentLength = bytes.Length;
                request.Timeout = 30 * 1000;

                string strBase64 = strUsername + ":" + strPassword;
                Byte[] bBase64 = new Byte[strBase64.Length];
                bBase64 = Encoding.UTF8.GetBytes(strBase64);
                strBase64 = Convert.ToBase64String(bBase64);
                request.Headers.Add("Authorization", strBase64);
                using (requestStream = request.GetRequestStream())
                {                    
                    Response.Write("REQPKG> " + strXml + "<br/>");

                    
                    requestStream.Write(bytes, 0, bytes.Length);
                    requestStream.Flush();
                    requestStream.Close();

                }


                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                responseStream = response.GetResponseStream();
                int length = (int)response.ContentLength;

                int bufSize = bufSizeMin;
                if (length > bufSize)
                    bufSize = length > bufSizeMax ? bufSizeMax : length;

                byte[] buf = new byte[bufSize];
                sb = new StringBuilder(bufSize);

                while ((length = responseStream.Read(buf, 0, buf.Length)) != 0)
                {
                    sb.Append(Encoding.UTF8.GetString(buf, 0, length));
                }
                Response.Write("RESPKG> " + sb.ToString() + "<br/>");
                if (!string.IsNullOrEmpty(sb.ToString()) && sb.ToString().IndexOf("<status>0</status>") > 0)
                {
                    blRet = true;
                }

            }
            catch (Exception e)
            {
                sb = new StringBuilder(e.Message);
            }
            finally
            {
                if (requestStream != null)
                    requestStream.Close();
                if (responseStream != null)
                    responseStream.Close();
            }
            return blRet;
        }

    }
}
